/*
   http://glprogramming.com/red/chapter05.html
*/

import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.awt.GLJPanel;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.util.gl2.GLUT;
import com.jogamp.opengl.glu.GLU;
import com.jogamp.opengl.util.FPSAnimator;

import javax.swing.JFrame;
import java.awt.event.*;

/**

*/
public class MoveLight implements GLEventListener, MouseListener
{
   public static int spin = 0;

   public MoveLight()
   {
      // Get a capabilities object from a GL2 profile.
      final GLProfile glProfile = GLProfile.get(GLProfile.GL2);
      final GLCapabilities glCapabilities = new GLCapabilities(glProfile);

      // Use it to create a GLJPanel.
      final GLJPanel glDrawable = new GLJPanel(glCapabilities);
      glDrawable.setPreferredSize(new java.awt.Dimension(500, 500));

      // Connect the GLJPanel with our GLEventListener implementation.
      glDrawable.addGLEventListener( this );

      // Add the GLJPanel to a JFrame.
      final JFrame jFrame = new JFrame ("Move Light");
      jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      jFrame.getContentPane().add(glDrawable);
      jFrame.pack();
      jFrame.setLocationRelativeTo(null);
      jFrame.setVisible(true);

      jFrame.addMouseListener(this);

      // Create an animation thread.
      final FPSAnimator animator = new FPSAnimator(glDrawable, 24, true);
      animator.start();
   }

   // Implement the GLEventListener interface (four methods).
   @Override
   public void init(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();

      gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
      gl.glShadeModel(gl.GL_SMOOTH); // try GL_FLAT
      gl.glEnable(gl.GL_LIGHTING);
      gl.glEnable(gl.GL_LIGHT0);
      gl.glEnable(gl.GL_DEPTH_TEST);
   }

   @Override
   public void display(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();

      // Here is where the light position is reset after the modeling
      // transformation (glRotated) is called.  This places the
      // light at a new position in world coordinates.  The cube
      // represents the position of the light.

      float[] position = {0.0f, 0.0f, 1.5f, 1.0f};

      gl.glClear(gl.GL_COLOR_BUFFER_BIT | gl.GL_DEPTH_BUFFER_BIT);
      gl.glPushMatrix();
        gl.glTranslated(0.0, 0.0, -5.0);

        gl.glPushMatrix();
          gl.glRotated((double)spin, 1.0, 0.0, 0.0);
          gl.glLightfv(gl.GL_LIGHT0, gl.GL_POSITION, position, 0);

          gl.glTranslated(0.0, 0.0, 1.5);
          gl.glDisable(gl.GL_LIGHTING);
          gl.glColor3f(0.0f, 1.0f, 1.0f);
          new GLUT().glutWireCube(0.1f);
          gl.glEnable(gl.GL_LIGHTING);
        gl.glPopMatrix();

        new GLUT().glutSolidTorus(0.275, 0.85, 8, 15);
      gl.glPopMatrix();
      gl.glFlush();
   }


   @Override
   public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h)
   {
      final GL2 gl = drawable.getGL().getGL2();
      final GLU glu = new GLU();  // GL Utilities

      gl.glViewport(0, 0, w, h);
      gl.glMatrixMode(gl.GL_PROJECTION);
      gl.glLoadIdentity();
      glu.gluPerspective(40.0f, (float)w/(float)h, 1.0f, 20.0f);
      gl.glMatrixMode(gl.GL_MODELVIEW);
      gl.glLoadIdentity();
   }


   @Override
   public void dispose(GLAutoDrawable drawable){}


   @Override
   public void mousePressed (MouseEvent e)
   {
      spin = (spin + 10) % 360;
   }
   @Override public void mouseReleased(MouseEvent e){}
   @Override public void mouseExited  (MouseEvent e){}
   @Override public void mouseEntered (MouseEvent e){}
   @Override public void mouseClicked (MouseEvent e){}


   public static void main(String[] args)
   {
      javax.swing.SwingUtilities.invokeLater(
         () -> new MoveLight()
      );
   }
}
